--//////////////////////////////////////////////
--Name: Caucausus Field A2A Defence System
--Dawger Modified example wih remarks
--//////////////////////////////////////////////

--////RED AIR DEFENCE

---Mission Editor Actions
--Create Late Activated Russian Helicopter Groups with one unit to define the following:
--
--Border Zone This Zone will determine the area the air defense system will react to threats. 
--The border may be omitted if you want the enemy to react to all detected threats anywhere on the map.
--The name of the Group will be used to define the zone in this script.
--In this example the border is defined by the group named "RussianBorderZone"
--
--CAP Zone(s)
--This zone will be the Combat Air Patrol area. This is the airspace the assigned CAP squadron will
--occupy when no tasked with intercepting a threat
--In this example there will be One CAP Zone defined by the late activated 
--helicopter group named "ScrambleBandits"
--
--Create Late Activated Groups with one unit for each desired aircraft type and loadout in the air defense system
--
--In this example, the CAP group based at Mineralnye Vody is represented by the group named "MinVody Su27 Group"
--For script portability I suggest simple names 
--
do
---Build a detection network. Define the network by creating units with the group name prefixes 
--that you define. These units may be of any type. They will detect threats based upon the capabilities
--of the unit. Obvious types are EWR and AWACS units but CAP fighters, SAM radars, and ground units
--could all be used. Again, use portable prefixes.
--
--In this example, I have added EWR sites and a Russian AWACS. Killing the detection units will degrade the
--response of the defense system.
  REDDetectionSetGroup = SET_GROUP:New()  
  REDDetectionSetGroup:FilterPrefixes( { "EWR RED", "AWACS RED","MinVody Su27 Group" } ) --Define the group prefixes to include
  REDDetectionSetGroup:FilterCoalitions("red")--define the coalition just in case you have group prefixes in use on both coalitions
  REDDetectionSetGroup:FilterStart()--Start the filter
  
  --This sets the area in which detected threats are considered as a single threat. Larger will mean less response, smaller will mean more
  REDDetection = DETECTION_AREAS:New( REDDetectionSetGroup, 30000 )--30 kilometer radius threat grouping
  
  --This creates the Dispatcher based upon the detection system built above.
  REDA2ADispatcher = AI_A2A_DISPATCHER:New( REDDetection )
  
  --Debug display. Set to true if you want to monitor how the dispatcher is behaving via an annoying 
  --text display
  REDA2ADispatcher:SetTacticalDisplay(false)
  
-- Setup the border zone. 
-- In this case the border is a POLYGON, 
-- which takes the waypoints of a late activated group with the name CCCP Border as the boundaries of the border area.
-- Any enemy crossing this border will be engaged. 
  RedBorderZone = ZONE_POLYGON:New( "RED Border", GROUP:FindByName( "RussianBorderZone" ) )
  REDA2ADispatcher:SetBorderZone( RedBorderZone )
  
--Set the fuel percentage for RTB for dispatched units. This is the global setting.
--This can also be done per squadron. Default is 15% if this command is not used.
  REDA2ADispatcher:SetDefaultFuelThreshold( 0.15 )
  --Set RTB damage threshold if desired
  --REDA2ADispatcher:SetDefaultDamageThreshold( 0.60 )
  
    
  --Global Air start altitude if desired
  --REDA2ADispatcher:SetDefaultTakeoffInAirAltitude(8000)

  --set the engage radius in meters for CAP squadrons
  --CAP squadrons are squadrons set to maintain a CAP in zone
  REDA2ADispatcher:SetEngageRadius( 300000 )--300km
  
  --If using ground based interceptor squadrons (called GCI here), set their engage radius here in meters
  REDA2ADispatcher:SetGciRadius( 300000 )
  
  --Define the radius to disengage any target 
  --when the distance to the home base is larger than the specified meters.
  REDA2ADispatcher:SetDisengageRadius( 500000 )--500km


  -- Setup the squadrons. The number is the amount of planes available.
  --////function AI_A2A_DISPATCHER:SetSquadron( SquadronName, AirbaseName, TemplatePrefixes, ResourceCount )

  -- These are all airbases of Caucasus:
  -- 
  -- AIRBASE.Caucasus.Gelendzhik
  -- AIRBASE.Caucasus.Krasnodar_Pashkovsky
  -- AIRBASE.Caucasus.Sukhumi_Babushara
  -- AIRBASE.Caucasus.Gudauta
  -- AIRBASE.Caucasus.Batumi
  -- AIRBASE.Caucasus.Senaki_Kolkhi
  -- AIRBASE.Caucasus.Kobuleti
  -- AIRBASE.Caucasus.Kutaisi
  -- AIRBASE.Caucasus.Tbilisi_Lochini
  -- AIRBASE.Caucasus.Soganlug
  -- AIRBASE.Caucasus.Vaziani
  -- AIRBASE.Caucasus.Anapa_Vityazevo
  -- AIRBASE.Caucasus.Krasnodar_Center
  -- AIRBASE.Caucasus.Novorossiysk
  -- AIRBASE.Caucasus.Krymsk
  -- AIRBASE.Caucasus.Maykop_Khanskaya
  -- AIRBASE.Caucasus.Sochi_Adler
  -- AIRBASE.Caucasus.Mineralnye_Vody
  -- AIRBASE.Caucasus.Nalchik
  -- AIRBASE.Caucasus.Mozdok
  -- AIRBASE.Caucasus.Beslan
  -- CV 1143.5 Admiral Kuznetsov
 --
 ---This script has the option for a CAP group patrolling over MinyVody area or a 
 --GCI group that will be dispatched when a threat crosses the border.
 --both sections may be used together or separately.
 --Remove the leading [[ and trailing  ]] to uncomment the GCI section
 --Comment out the entire section if not desired
 
 --******************************************************************************
 --******************************************************************************
  --This section is for Combat Air Patrol Setup using the MinVody Squadron Template
  -- ////CAP Squadrons
  -- This sets the MinVodyCAP squadron to use the MinVody Su27 Group template and be limited to 12 aircraft total.
  --
  -- IF YOU WANT LESS OR MORE TOTAL BANDITS CHANGE THE LAST NUMBER
  REDA2ADispatcher:SetSquadron( "MinVodyCAP", AIRBASE.Caucasus.Mineralnye_Vody, { "MinVody Su27 Group" }, 4 )
  
  --////SQUADRON GROUPING
  --How many aircraft will be dispatched together
  REDA2ADispatcher:SetSquadronGrouping( "MinVodyCAP", 2 )--2 aircraft will be dispatched each time
  
  --////SQUADRON OVERHEAD
  --Overhead determines how many aircraft the will be dispatched as a percentage of detected enemy aircraft.
  --Squadrons are dispatched according to grouping so be sure to set grouping and overhead to achieve the desired outcome
  REDA2ADispatcher:SetSquadronOverhead( "MinVodyCAP", 0.25)--25% one group will be dispatched for every 4 enemy aircraft detected
  
  --Set the squadron tanker where defenders will Refuel in the air.
  REDA2ADispatcher:SetSquadronTanker("MinVodyCAP","REDTANKER1")
  --Set Air spawn altitude for squadron
  REDA2ADispatcher:SetSquadronTakeoffInAirAltitude("MinVodyCAP",1200)
  
  --////TAKEOFF Options
  --Takeoff in Air is recommended as other methods can lead to problems
  --2.5.6 currently does not work with anything except takeoff in air
  --REDA2ADispatcher:SetSquadronTakeoffFromParkingHot( "MinVodyCAP" )
    
  --REDA2ADispatcher:SetSquadronTakeoffFromRunway( "MinVodyCAP" )
    
  REDA2ADispatcher:SetSquadronTakeoffInAir( "MinVodyCAP" )
  
  --REDA2ADispatcher:SetSquadronTakeoffFromParkingCold("MinVodyCAP")

  --////LANDING Options
  --Determines the point at which the group is despawned
  REDA2ADispatcher:SetSquadronLandingAtRunway( "MinVodyCAP" )
  --REDA2ADispatcher:SetSquadronLandingAtEngineShutdown(SquadronName)
  --REDA2ADispatcher:SetSquadronLandingNearAirbase(SquadronName)
  
  
  --Create the Combat Air Patrol area
 CAPZoneRed1 = ZONE_POLYGON:New( "CAP Zone RED Mineral Water Area",GROUP:FindByName("ScrambleBandits"))
  
  
  --Set Squadrons assigned to patrol
  --function AI_A2A_DISPATCHER:SetSquadronCap( SquadronName, Zone, FloorAltitude, CeilingAltitude, PatrolMinSpeed, PatrolMaxSpeed, EngageMinSpeed, EngageMaxSpeed, AltType )
  --Everything is metric. Altitude is meters, speeds are kph.  
  REDA2ADispatcher:SetSquadronCap( "MinVodyCAP", CAPZoneRed1, 4000, 11000, 750, 900, 800, 1200, "BARO" )
  
  --Set the dispatch intervals. In this example, the minimum interval is 10 minutes (600 seconds)
  --and the maximum is 1 hour(3600). Use this to adjus times between CAp dispatch after CAP is destroyed or RTB
  --
  ---AI\_A2A\_DISPATCHER:SetSquadronCapInterval(SquadronName, CapLimit, LowInterval, HighInterval, Probability) 
  --Parameters
---�#string SquadronName : The squadron name.
---�#number CapLimit : (optional) The maximum amount of CAP groups to be spawned. Note that a CAP is a group, so can consist out of 1 to 4 airplanes. The default is 1 CAP group.
---#number LowInterval : (optional) The minimum time boundary in seconds when a new CAP will be spawned. The default is 180 seconds.
---�#number HighInterval : (optional) The maximum time boundary in seconds when a new CAP will be spawned. The default is 600 seconds.
---�#number Probability : Is not in use, you can skip this parameter.

  REDA2ADispatcher:SetSquadronCapInterval( "MinVodyCAP", 1, 600, 900, 1 )
  
  --END OF CAP SECTION
  --*****************************************************************************
  --*****************************************************************************  
  
  --This Section is ground based interceptor setup using MinVody Squadron Template
  --***********************************************************************************
  --***********************************************************************************
  -- This sets the MinVodyGCI squadron to use the MinVody Su27 Group template and be limited to 12 aircraft total
  REDA2ADispatcher:SetSquadron("MinVodyGCI",AIRBASE.Caucasus.Mineralnye_Vody, { "MinVody Su27 Group" }, 6 )
  --Set Squadron to be dispatched when threat detected crossing border
  --AI\_A2A\_DISPATCHER:SetSquadronGci(SquadronName, EngageMinSpeed, EngageMaxSpeed)  
  REDA2ADispatcher:SetSquadronGci("MinVodyGCI",900,1300)
  --////SQUADRON OVERHEAD
  --Overhead determines how many aircraft the will be dispatched as a percentage of detected enemy aircraft.
  --Squadrons are dispatched according to grouping so be sure to set grouping and overhead to achieve the desired outcome
  REDA2ADispatcher:SetSquadronOverhead("MinVodyGCI",1)
  --////SQUADRON GROUPING
  --How many aircraft will be dispatched together
  REDA2ADispatcher:SetSquadronGrouping("MinVodyGCI",4)
  --////TAKEOFF Options
  --Takeoff in Air is recommended as other methods can lead to problems
  --2.5.6 currently does not work with anything except takeoff in air
  --REDA2ADispatcher:SetSquadronTakeoffFromParkingHot( "MinVodyGCI" )
    
  --REDA2ADispatcher:SetSquadronTakeoffFromRunway( "MinVodyGCI" )
  REDA2ADispatcher:SetSquadronTakeoffInAir("MinVodyGCI",1000)
  
  --Landing Options
  REDA2ADispatcher:SetSquadronLandingAtRunway("MinVodyGCI")
  --REDA2ADispatcher:SetSquadronLandingAtEngineShutdown(SquadronName)
  --REDA2ADispatcher:SetSquadronLandingNearAirbase(SquadronName)
  
  --END GCI SECTION
  --***************************************************************
  --**************************************************************
  
  REDA2ADispatcher:Start()


end
